Function CATIADrawing_Update_After(ApplHndl As Long,Sstr As String,FirstPar As Long,SecondPar As Long,ThirdPar As Long ) As Integer

    Dim SmSession       As ISmSession
    Dim FirstRec        As Object
    Dim SmObject        As SmApplic.ISmObject

    CONV_RecListToComRecordList FirstPar,FirstRec 

    Set SmSession 		= SCREXT_ObjectForInterface(ApplHndl) 
	Set SmObject 		= SmSession.ObjectStore.ObjectFromData(FirstRec.GetRecord(0), True)
	Set QueryDefDummy = SmSession.ObjectStore.NewQueryDefinition	
	Set SmObjsDependencies = SmObject.RetrieveDependencies(QueryDefDummy)

	SmSession.ObjectStore.DefaultBehavior.InvokeScripts = False

	If SmObjsDependencies.Count > 0 Then
		Set SmObjLinked = SmObjsDependencies.Item(0).Clone
		SmObjLinked.Retrieve
		SmObject.Retrieve
		SmObject.Data.Value("CN_3D_PART_NUMBER") = SmObjLinked.Data.Value("CN_PART_NUMBER")
		SmObject.Data.Value("CN_3D_REVISION") = SmObjLinked.Data.Value("CN_REVISION")
		SmObject.Update
	
	End If

End Function

Function CATIADAL_Add_After(ApplHndl As Long,Sstr As String,FirstPar As Long,SecondPar As Long,ThirdPar As Long ) As Integer
' Attach at CATIA Downstream Application Link Add After
	
    Dim SmSession       As ISmSession
    Dim FirstRec        As Object
    Dim SmObject        As SmApplic.ISmObject

    CONV_RecListToComRecordList FirstPar, FirstRec

    Set SmSession = SCREXT_ObjectForInterface(ApplHndl)
	Set SmObject = SmSession.ObjectStore.ObjectFromData(FirstRec.GetRecord(0), True)
    
    Dim intClsIDDrawing                 As Integer
    Dim intClsIDPart                    As Integer
    Dim intClsIDProduct                 As Integer
    Dim SmObjDrawing                    As SmApplic.ISmObject
    Dim SmObj3D                     	As SmApplic.ISmObject
    
    intClsIDDrawing = SmSession.Metainfo.SmClassByName("CATIA Drawing").ClassId
    intClsIDPart = SmSession.Metainfo.SmClassByName("CATIA Part").ClassId
    intClsIDProduct = SmSession.Metainfo.SmClassByName("CATIA Product").ClassId
    
    ' Determine the type of link and assign Child (receipent) and master (source)
    If SmObject.Data.Value("CLASS_ID1") = intClsIDDrawing Then
    
        Select Case SmObject.Data.Value("CLASS_ID2")
                       
            Case intClsIDPart
                Set SmObj3D = SmSession.ObjectStore.RetrieveObject(intClsIDPart, SmObject.Data.Value("OBJECT_ID2"))
                Set SmObjDrawing = SmSession.ObjectStore.RetrieveObject(intClsIDDrawing, SmObject.Data.Value("OBJECT_ID1")).Clone
            
            Case intClsIDProduct
                Set SmObj3D = SmSession.ObjectStore.RetrieveObject(intClsIDProduct, SmObject.Data.Value("OBJECT_ID2"))
                Set SmObjDrawing = SmSession.ObjectStore.RetrieveObject(intClsIDDrawing, SmObject.Data.Value("OBJECT_ID1")).Clone
         
            Case Else
            
                Exit Function
        
            End Select
        
    ElseIf SmObject.Data.Value("CLASS_ID2") = intClsIDDrawing Then
    
        Select Case SmObject.Data.Value("CLASS_ID1")
            
            Case intClsIDPart
                Set SmObj3D = SmSession.ObjectStore.RetrieveObject(intClsIDPart, SmObject.Data.Value("OBJECT_ID1")).Clone
                Set SmObjDrawing = SmSession.ObjectStore.RetrieveObject(intClsIDDrawing, SmObject.Data.Value("OBJECT_ID2")).Clone
        
            Case intClsIDProduct
                Set SmObj3D = SmSession.ObjectStore.RetrieveObject(intClsIDProduct, SmObject.Data.Value("OBJECT_ID1")).Clone
                Set SmObjDrawing = SmSession.ObjectStore.RetrieveObject(intClsIDDrawing, SmObject.Data.Value("OBJECT_ID2"))
                
            Case Else
            
                Exit Function
        
            End Select

    Else
    
        Exit Function
    
    End If

	SmSession.ObjectStore.DefaultBehavior.InvokeScripts = False

	SmObj3D.Retrieve
	SmObjDrawing.Retrieve
	SmObjDrawing.Data.Value("CN_3D_PART_NUMBER") = SmObj3D.Data.Value("CN_PART_NUMBER")
	SmObjDrawing.Data.Value("CN_3D_REVISION") = SmObj3D.Data.Value("CN_REVISION")
	SmObjDrawing.Update
		

End Function


